// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'json_flexible_builder.dart';

// **************************************************************************
// Generator: JsonWidgetLibraryBuilder
// **************************************************************************

// ignore_for_file: avoid_init_to_null
// ignore_for_file: deprecated_member_use

// ignore_for_file: prefer_const_constructors
// ignore_for_file: prefer_const_constructors_in_immutables
// ignore_for_file: prefer_final_locals
// ignore_for_file: prefer_if_null_operators
// ignore_for_file: prefer_single_quotes
// ignore_for_file: unused_local_variable

class JsonFlexibleBuilder extends _JsonFlexibleBuilder {
  const JsonFlexibleBuilder({required super.args});

  static const kType = 'flexible';

  /// Constant that can be referenced for the builder's type.
  @override
  String get type => kType;

  /// Static function that is capable of decoding the widget from a dynamic JSON
  /// or YAML set of values.
  static JsonFlexibleBuilder fromDynamic(
    dynamic map, {
    JsonWidgetRegistry? registry,
  }) =>
      JsonFlexibleBuilder(
        args: map,
      );

  @override
  JsonFlexibleBuilderModel createModel({
    ChildWidgetBuilder? childBuilder,
    required JsonWidgetData data,
  }) {
    final model = JsonFlexibleBuilderModel.fromDynamic(
      args,
      registry: data.jsonWidgetRegistry,
    );

    return model;
  }

  @override
  Flexible buildCustom({
    ChildWidgetBuilder? childBuilder,
    required BuildContext context,
    required JsonWidgetData data,
    Key? key,
  }) {
    final model = createModel(
      childBuilder: childBuilder,
      data: data,
    );

    return Flexible(
      fit: model.fit,
      flex: model.flex,
      key: key,
      child: model.child.build(
        childBuilder: childBuilder,
        context: context,
      ),
    );
  }
}

class JsonFlexible extends JsonWidgetData {
  JsonFlexible({
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
    this.fit = FlexFit.loose,
    this.flex = 1,
    required this.child,
  }) : super(
          jsonWidgetArgs: JsonFlexibleBuilderModel.fromDynamic(
            {
              'fit': fit,
              'flex': flex,
              'child': child,
              ...args,
            },
            args: args,
            registry: registry,
          ),
          jsonWidgetBuilder: () => JsonFlexibleBuilder(
            args: JsonFlexibleBuilderModel.fromDynamic(
              {
                'fit': fit,
                'flex': flex,
                'child': child,
                ...args,
              },
              args: args,
              registry: registry,
            ),
          ),
          jsonWidgetType: JsonFlexibleBuilder.kType,
        );

  /* AUTOGENERATED FROM [Flexible.fit]*/
  /// How a flexible child is inscribed into the available space.
  ///
  /// If [flex] is non-zero, the [fit] determines whether the child fills the
  /// space the parent makes available during layout. If the fit is
  /// [FlexFit.tight], the child is required to fill the available space. If the
  /// fit is [FlexFit.loose], the child can be at most as large as the available
  /// space (but is allowed to be smaller).
  final FlexFit fit;

  /* AUTOGENERATED FROM [Flexible.flex]*/
  /// The flex factor to use for this child.
  ///
  /// If null or zero, the child is inflexible and determines its own size. If
  /// non-zero, the amount of space the child's can occupy in the main axis is
  /// determined by dividing the free space (after placing the inflexible
  /// children) according to the flex factors of the flexible children.
  final int flex;

  final JsonWidgetData child;
}

/* AUTOGENERATED FROM [Flexible]*/
/// Creates a widget that controls how a child of a [Row], [Column], or [Flex]
/// flexes.
class JsonFlexibleBuilderModel extends JsonWidgetBuilderModel {
  const JsonFlexibleBuilderModel(
    super.args, {
    this.fit = FlexFit.loose,
    this.flex = 1,
    required this.child,
  });

  /* AUTOGENERATED FROM [Flexible.fit]*/
  /// How a flexible child is inscribed into the available space.
  ///
  /// If [flex] is non-zero, the [fit] determines whether the child fills the
  /// space the parent makes available during layout. If the fit is
  /// [FlexFit.tight], the child is required to fill the available space. If the
  /// fit is [FlexFit.loose], the child can be at most as large as the available
  /// space (but is allowed to be smaller).
  final FlexFit fit;

  /* AUTOGENERATED FROM [Flexible.flex]*/
  /// The flex factor to use for this child.
  ///
  /// If null or zero, the child is inflexible and determines its own size. If
  /// non-zero, the amount of space the child's can occupy in the main axis is
  /// determined by dividing the free space (after placing the inflexible
  /// children) according to the flex factors of the flexible children.
  final int flex;

  final JsonWidgetData child;

  static JsonFlexibleBuilderModel fromDynamic(
    dynamic map, {
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
  }) {
    final result = maybeFromDynamic(
      map,
      args: args,
      registry: registry,
    );

    if (result == null) {
      throw Exception(
        '[JsonFlexibleBuilder]: requested to parse from dynamic, but the input is null.',
      );
    }

    return result;
  }

  static JsonFlexibleBuilderModel? maybeFromDynamic(
    dynamic map, {
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
  }) {
    JsonFlexibleBuilderModel? result;

    if (map != null) {
      if (map is String) {
        map = yaon.parse(
          map,
          normalize: true,
        );
      }

      if (map is JsonFlexibleBuilderModel) {
        result = map;
      } else {
        registry ??= JsonWidgetRegistry.instance;
        map = registry.processArgs(map, <String>{}).value;
        result = JsonFlexibleBuilderModel(
          args,
          fit: () {
            dynamic parsed = ThemeDecoder.decodeFlexFit(
              map['fit'],
              validate: false,
            );
            parsed ??= FlexFit.loose;

            return parsed;
          }(),
          flex: () {
            dynamic parsed = JsonClass.maybeParseInt(map['flex']);

            parsed ??= 1;

            return parsed;
          }(),
          child: () {
            dynamic parsed = JsonWidgetData.fromDynamic(
              map['child'],
              registry: registry,
            );

            if (parsed == null) {
              throw Exception(
                  'Null value encountered for required parameter: [child].');
            }
            return parsed;
          }(),
        );
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toJson() {
    return JsonClass.removeNull({
      'fit': FlexFit.loose == fit
          ? null
          : ThemeEncoder.encodeFlexFit(
              fit,
            ),
      'flex': 1 == flex ? null : flex,
      'child': child.toJson(),
      ...args,
    });
  }
}

class FlexibleSchema {
  static const id =
      'https://peiffer-innovations.github.io/flutter_json_schemas/schemas/json_dynamic_widget/flexible.json';

  static final schema = <String, Object>{
    r'$schema': 'http://json-schema.org/draft-07/schema#',
    r'$id': id,
    'title': 'Flexible',
    'type': 'object',
    'additionalProperties': false,
    'properties': {
      'fit': SchemaHelper.objectSchema(FlexFitSchema.id),
      'flex': SchemaHelper.numberSchema,
      'child': SchemaHelper.objectSchema(JsonWidgetDataSchema.id),
    },
  };
}
