// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'json_positioned_builder.dart';

// **************************************************************************
// Generator: JsonWidgetLibraryBuilder
// **************************************************************************

// ignore_for_file: avoid_init_to_null
// ignore_for_file: deprecated_member_use

// ignore_for_file: prefer_const_constructors
// ignore_for_file: prefer_const_constructors_in_immutables
// ignore_for_file: prefer_final_locals
// ignore_for_file: prefer_if_null_operators
// ignore_for_file: prefer_single_quotes
// ignore_for_file: unused_local_variable

class JsonPositionedBuilder extends _JsonPositionedBuilder {
  const JsonPositionedBuilder({required super.args});

  static const kType = 'positioned';

  /// Constant that can be referenced for the builder's type.
  @override
  String get type => kType;

  /// Static function that is capable of decoding the widget from a dynamic JSON
  /// or YAML set of values.
  static JsonPositionedBuilder fromDynamic(
    dynamic map, {
    JsonWidgetRegistry? registry,
  }) =>
      JsonPositionedBuilder(
        args: map,
      );

  @override
  JsonPositionedBuilderModel createModel({
    ChildWidgetBuilder? childBuilder,
    required JsonWidgetData data,
  }) {
    final model = JsonPositionedBuilderModel.fromDynamic(
      args,
      registry: data.jsonWidgetRegistry,
    );

    return model;
  }

  @override
  Positioned buildCustom({
    ChildWidgetBuilder? childBuilder,
    required BuildContext context,
    required JsonWidgetData data,
    Key? key,
  }) {
    final model = createModel(
      childBuilder: childBuilder,
      data: data,
    );

    return Positioned(
      bottom: model.bottom,
      height: model.height,
      key: key,
      left: model.left,
      right: model.right,
      top: model.top,
      width: model.width,
      child: model.child.build(
        childBuilder: childBuilder,
        context: context,
      ),
    );
  }
}

class JsonPositioned extends JsonWidgetData {
  JsonPositioned({
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
    this.bottom,
    this.height,
    this.left,
    this.right,
    this.top,
    this.width,
    required this.child,
  }) : super(
          jsonWidgetArgs: JsonPositionedBuilderModel.fromDynamic(
            {
              'bottom': bottom,
              'height': height,
              'left': left,
              'right': right,
              'top': top,
              'width': width,
              'child': child,
              ...args,
            },
            args: args,
            registry: registry,
          ),
          jsonWidgetBuilder: () => JsonPositionedBuilder(
            args: JsonPositionedBuilderModel.fromDynamic(
              {
                'bottom': bottom,
                'height': height,
                'left': left,
                'right': right,
                'top': top,
                'width': width,
                'child': child,
                ...args,
              },
              args: args,
              registry: registry,
            ),
          ),
          jsonWidgetType: JsonPositionedBuilder.kType,
        );

  /* AUTOGENERATED FROM [Positioned.bottom]*/
  /// The distance that the child's bottom edge is inset from the bottom of the stack.
  ///
  /// Only two out of the three vertical values ([top], [bottom], [height]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// vertically.
  final double? bottom;

  /* AUTOGENERATED FROM [Positioned.height]*/
  /// The child's height.
  ///
  /// Only two out of the three vertical values ([top], [bottom], [height]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// vertically.
  final double? height;

  /* AUTOGENERATED FROM [Positioned.left]*/
  /// The distance that the child's left edge is inset from the left of the stack.
  ///
  /// Only two out of the three horizontal values ([left], [right], [width]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// horizontally.
  final double? left;

  /* AUTOGENERATED FROM [Positioned.right]*/
  /// The distance that the child's right edge is inset from the right of the stack.
  ///
  /// Only two out of the three horizontal values ([left], [right], [width]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// horizontally.
  final double? right;

  /* AUTOGENERATED FROM [Positioned.top]*/
  /// The distance that the child's top edge is inset from the top of the stack.
  ///
  /// Only two out of the three vertical values ([top], [bottom], [height]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// vertically.
  final double? top;

  /* AUTOGENERATED FROM [Positioned.width]*/
  /// The child's width.
  ///
  /// Only two out of the three horizontal values ([left], [right], [width]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// horizontally.
  final double? width;

  final JsonWidgetData child;
}

/* AUTOGENERATED FROM [Positioned]*/
/// Creates a widget that controls where a child of a [Stack] is positioned.
///
/// Only two out of the three horizontal values ([left], [right],
/// [width]), and only two out of the three vertical values ([top],
/// [bottom], [height]), can be set. In each case, at least one of
/// the three must be null.
///
/// See also:
///
///  * [Positioned.directional], which specifies the widget's horizontal
///    position using `start` and `end` rather than `left` and `right`.
///  * [PositionedDirectional], which is similar to [Positioned.directional]
///    but adapts to the ambient [Directionality].
class JsonPositionedBuilderModel extends JsonWidgetBuilderModel {
  const JsonPositionedBuilderModel(
    super.args, {
    this.bottom,
    this.height,
    this.left,
    this.right,
    this.top,
    this.width,
    required this.child,
  });

  /* AUTOGENERATED FROM [Positioned.bottom]*/
  /// The distance that the child's bottom edge is inset from the bottom of the stack.
  ///
  /// Only two out of the three vertical values ([top], [bottom], [height]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// vertically.
  final double? bottom;

  /* AUTOGENERATED FROM [Positioned.height]*/
  /// The child's height.
  ///
  /// Only two out of the three vertical values ([top], [bottom], [height]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// vertically.
  final double? height;

  /* AUTOGENERATED FROM [Positioned.left]*/
  /// The distance that the child's left edge is inset from the left of the stack.
  ///
  /// Only two out of the three horizontal values ([left], [right], [width]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// horizontally.
  final double? left;

  /* AUTOGENERATED FROM [Positioned.right]*/
  /// The distance that the child's right edge is inset from the right of the stack.
  ///
  /// Only two out of the three horizontal values ([left], [right], [width]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// horizontally.
  final double? right;

  /* AUTOGENERATED FROM [Positioned.top]*/
  /// The distance that the child's top edge is inset from the top of the stack.
  ///
  /// Only two out of the three vertical values ([top], [bottom], [height]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// vertically.
  final double? top;

  /* AUTOGENERATED FROM [Positioned.width]*/
  /// The child's width.
  ///
  /// Only two out of the three horizontal values ([left], [right], [width]) can be
  /// set. The third must be null.
  ///
  /// If all three are null, the [Stack.alignment] is used to position the child
  /// horizontally.
  final double? width;

  final JsonWidgetData child;

  static JsonPositionedBuilderModel fromDynamic(
    dynamic map, {
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
  }) {
    final result = maybeFromDynamic(
      map,
      args: args,
      registry: registry,
    );

    if (result == null) {
      throw Exception(
        '[JsonPositionedBuilder]: requested to parse from dynamic, but the input is null.',
      );
    }

    return result;
  }

  static JsonPositionedBuilderModel? maybeFromDynamic(
    dynamic map, {
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
  }) {
    JsonPositionedBuilderModel? result;

    if (map != null) {
      if (map is String) {
        map = yaon.parse(
          map,
          normalize: true,
        );
      }

      if (map is JsonPositionedBuilderModel) {
        result = map;
      } else {
        registry ??= JsonWidgetRegistry.instance;
        map = registry.processArgs(map, <String>{}).value;
        result = JsonPositionedBuilderModel(
          args,
          bottom: () {
            dynamic parsed = JsonClass.maybeParseDouble(map['bottom']);

            return parsed;
          }(),
          height: () {
            dynamic parsed = JsonClass.maybeParseDouble(map['height']);

            return parsed;
          }(),
          left: () {
            dynamic parsed = JsonClass.maybeParseDouble(map['left']);

            return parsed;
          }(),
          right: () {
            dynamic parsed = JsonClass.maybeParseDouble(map['right']);

            return parsed;
          }(),
          top: () {
            dynamic parsed = JsonClass.maybeParseDouble(map['top']);

            return parsed;
          }(),
          width: () {
            dynamic parsed = JsonClass.maybeParseDouble(map['width']);

            return parsed;
          }(),
          child: () {
            dynamic parsed = JsonWidgetData.fromDynamic(
              map['child'],
              registry: registry,
            );

            if (parsed == null) {
              throw Exception(
                  'Null value encountered for required parameter: [child].');
            }
            return parsed;
          }(),
        );
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toJson() {
    return JsonClass.removeNull({
      'bottom': bottom,
      'height': height,
      'left': left,
      'right': right,
      'top': top,
      'width': width,
      'child': child.toJson(),
      ...args,
    });
  }
}

class PositionedSchema {
  static const id =
      'https://peiffer-innovations.github.io/flutter_json_schemas/schemas/json_dynamic_widget/positioned.json';

  static final schema = <String, Object>{
    r'$schema': 'http://json-schema.org/draft-07/schema#',
    r'$id': id,
    'title': 'Positioned',
    'type': 'object',
    'additionalProperties': false,
    'properties': {
      'bottom': SchemaHelper.numberSchema,
      'height': SchemaHelper.numberSchema,
      'left': SchemaHelper.numberSchema,
      'right': SchemaHelper.numberSchema,
      'top': SchemaHelper.numberSchema,
      'width': SchemaHelper.numberSchema,
      'child': SchemaHelper.objectSchema(JsonWidgetDataSchema.id),
    },
  };
}
