// ignore_for_file: constant_identifier_names

import 'package:flutter/animation.dart';

class CurvesValues {
  static const curves_key_bounce_in = 'bounce_in_curve';
  static const curves_key_bounce_in_out = 'bounce_in_out_curve';
  static const curves_key_bounce_out = 'bounce_out_curve';
  static const curves_key_decelerate = 'decelerate_curve';
  static const curves_key_ease = 'ease_curve';
  static const curves_key_ease_in = 'ease_in_curve';
  static const curves_key_ease_in_back = 'ease_in_back_curve';
  static const curves_key_ease_in_circ = 'ease_in_circ_curve';
  static const curves_key_ease_in_cubic = 'ease_in_cubic_curve';
  static const curves_key_ease_in_expo = 'ease_in_expo_curve';
  static const curves_key_ease_in_out = 'ease_in_out_curve';
  static const curves_key_ease_in_out_back = 'ease_in_out_back_curve';
  static const curves_key_ease_in_out_circ = 'ease_in_out_circ_curve';
  static const curves_key_ease_in_out_cubic = 'ease_in_out_cubic_curve';
  static const curves_key_ease_in_out_expo = 'ease_in_out_expo_curve';
  static const curves_key_ease_in_out_quad = 'ease_in_out_quad_curve';
  static const curves_key_ease_in_out_quart = 'ease_in_out_quart_curve';
  static const curves_key_ease_in_out_quint = 'ease_in_out_quint_curve';
  static const curves_key_ease_in_out_sine = 'ease_in_out_sine_curve';
  static const curves_key_ease_in_quad = 'ease_in_quad_curve';
  static const curves_key_ease_in_quart = 'ease_in_quart_curve';
  static const curves_key_ease_in_quint = 'ease_in_quint_curve';
  static const curves_key_ease_in_sine = 'ease_in_sine_curve';
  static const curves_key_ease_in_to_linear = 'ease_in_to_linear_curve';
  static const curves_key_ease_out = 'ease_out_curve';
  static const curves_key_ease_out_back = 'ease_out_back_curve';
  static const curves_key_ease_out_circ = 'ease_out_circ_curve';
  static const curves_key_ease_out_cubic = 'ease_out_cubic_curve';
  static const curves_key_ease_out_expo = 'ease_out_expo_curve';
  static const curves_key_ease_out_quad = 'ease_out_quad_curve';
  static const curves_key_ease_out_quart = 'ease_out_quart_curve';
  static const curves_key_ease_out_quint = 'ease_out_quint_curve';
  static const curves_key_ease_out_sine = 'ease_out_sine_curve';
  static const curves_key_elastic_in = 'elastic_in_curve';
  static const curves_key_elastic_in_out = 'elastic_in_out_curve';
  static const curves_key_elastic_out = 'elastic_out_curve';
  static const curves_key_fast_linear_to_slow_ease_in =
      'fast_linear_to_slow_ease_in_curve';
  static const curves_key_fast_out_slow_in = 'fast_out_slow_in_curve';
  static const curves_key_linear = 'linear_curve';
  static const curves_key_linear_to_ease_out = 'linear_to_ease_out_curve';
  static const curves_key_slow_middle = 'slow_middle_curve';

  static String? encode(dynamic curve) {
    String? result;

    if (curve is String) {
      result = curve;
    } else if (curve is Curve) {
      try {
        result = values.entries.firstWhere((e) => e.value == curve).key;
      } catch (e) {
        // no-op
      }
    }

    return result;
  }

  static Curve? lookup(dynamic curve) => curve is Curve ? curve : values[curve];

  static const values = {
    curves_key_bounce_in: Curves.bounceIn,
    curves_key_bounce_in_out: Curves.bounceInOut,
    curves_key_bounce_out: Curves.bounceOut,
    curves_key_decelerate: Curves.decelerate,
    curves_key_ease: Curves.ease,
    curves_key_ease_in: Curves.easeIn,
    curves_key_ease_in_back: Curves.easeInBack,
    curves_key_ease_in_circ: Curves.easeInCirc,
    curves_key_ease_in_cubic: Curves.easeInCubic,
    curves_key_ease_in_expo: Curves.easeInExpo,
    curves_key_ease_in_out: Curves.easeInOut,
    curves_key_ease_in_out_back: Curves.easeInOutBack,
    curves_key_ease_in_out_circ: Curves.easeInOutCirc,
    curves_key_ease_in_out_cubic: Curves.easeInOutCubic,
    curves_key_ease_in_out_expo: Curves.easeInOutExpo,
    curves_key_ease_in_out_quad: Curves.easeInOutQuad,
    curves_key_ease_in_out_quart: Curves.easeInOutQuart,
    curves_key_ease_in_out_quint: Curves.easeInOutQuint,
    curves_key_ease_in_out_sine: Curves.easeInOutSine,
    curves_key_ease_in_quad: Curves.easeInQuad,
    curves_key_ease_in_quart: Curves.easeInQuart,
    curves_key_ease_in_quint: Curves.easeInQuint,
    curves_key_ease_in_sine: Curves.easeInSine,
    curves_key_ease_in_to_linear: Curves.easeInToLinear,
    curves_key_ease_out: Curves.easeOut,
    curves_key_ease_out_back: Curves.easeOutBack,
    curves_key_ease_out_circ: Curves.easeOutCirc,
    curves_key_ease_out_cubic: Curves.easeOutCubic,
    curves_key_ease_out_expo: Curves.easeOutExpo,
    curves_key_ease_out_quad: Curves.easeOutQuad,
    curves_key_ease_out_quart: Curves.easeOutQuart,
    curves_key_ease_out_quint: Curves.easeOutQuint,
    curves_key_ease_out_sine: Curves.easeOutSine,
    curves_key_elastic_in: Curves.elasticIn,
    curves_key_elastic_in_out: Curves.elasticInOut,
    curves_key_elastic_out: Curves.elasticOut,
    curves_key_fast_linear_to_slow_ease_in: Curves.fastLinearToSlowEaseIn,
    curves_key_fast_out_slow_in: Curves.fastOutSlowIn,
    curves_key_linear: Curves.linear,
    curves_key_linear_to_ease_out: Curves.linearToEaseOut,
    curves_key_slow_middle: Curves.slowMiddle,
  };
}
